<?php

/*
	Tovolt - Responsive q2a theme
	http://www.tovolt.com
	Rahul Aryan
===========================================================
	Question2Answer (c) Gideon Greenspan
	http://www.question2answer.org
	More about this license: http://www.question2answer.org/license.php
*/

	class qa_html_theme extends qa_html_theme_base
	{	
		function html()
		{
			$this->output(
				'<!-- paulirish.com/2008/conditional-stylesheets-vs-css-hacks-answer-neither/ -->
<!--[if lt IE 7]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="en"> <![endif]-->
<!--[if IE 7]>    <html class="no-js lt-ie9 lt-ie8" lang="en"> <![endif]-->
<!--[if IE 8]>    <html class="no-js lt-ie9" lang="en"> <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js '.(qa_opt('tovolt_plugin_e_rtl') ? 'rtl' : '').'" lang="en"> <!--<![endif]-->'
			);
			
			$this->head();
			$this->body();
			
			$this->output(
				'</HTML>'
			);
		}
		function doctype()
		{
			$this->output('<!DOCTYPE HTML>');
		}
		function head_script() // change style of WYSIWYG editor to match theme better
		{
		
			qa_html_theme_base::head_script();
			
			$this->output(
				'<SCRIPT TYPE="text/javascript" src="'.$this->rooturl.'js/hoverIntent.minified.js"></SCRIPT>',
				'<SCRIPT TYPE="text/javascript" src="'.$this->rooturl.'js/tovolt.js"></SCRIPT>'
			);

			if (qa_opt('tovolt_pligin_an')) { 
				
				$this->content['script'][]='<script type="text/javascript">'.
				'var _gaq = _gaq || [];'.
				'_gaq.push([\'_setAccount\', \''.qa_opt('tovolt_pligin_an').'\']);'.
				'_gaq.push([\'_trackPageview\']);'.
				'(function() {'.
				'var ga = document.createElement(\'script\'); ga.type = \'text/javascript\'; ga.async = true;'.
				'ga.src = (\'https:\' == document.location.protocol ? \'https://ssl\' : \'http://www\') + \'.google-analytics.com/ga.js\';'.
				'var s = document.getElementsByTagName(\'script\')[0]; s.parentNode.insertBefore(ga, s);'.
				'})();'.
				'</script>';
					
				
			}
	
		}
		function head_css()
		{
			$this->output('<link href="'.$this->rooturl.'favicon.ico" rel="shortcut icon">');
			qa_html_theme_base::head_css();
			$this->output('<LINK REL="stylesheet" TYPE="text/css" HREF="'.$this->rooturl.'foundation.css"/>');
			$this->output('<LINK REL="stylesheet" TYPE="text/css" HREF="'.$this->rooturl.'font/style.css"/>');
			if (qa_opt('tovolt_plugin_e_rtl')) {
				$this->output('<LINK REL="stylesheet" TYPE="text/css" HREF="'.$this->rooturl.'rtl.css"/>');
			}
			$this->output('<link href="http://fonts.googleapis.com/css?family=Roboto+Condensed" rel="stylesheet" type="text/css">',	'<link href="'.$this->rooturl.'js/prettify/prettify.css" type="text/css" rel="stylesheet" />', '<script type="text/javascript" src="'.$this->rooturl.'js/prettify/prettify.js"></script>');
			
			$this->output('<style>');				
				$this->output('.qa-logo-link, .qa-logo-link:hover {
					background: url("'.$this->rooturl.qa_opt('tovolt_plugin_logo').'") no-repeat scroll 0 0 transparent;
				}
				'.qa_opt('tovolt_plugin_css').'
				');				
			$this->output('</style>');

		}

		function head_metas(){
			qa_html_theme_base::head_metas();
			$this->output('<meta name="viewport" content="width=device-width" />');
			
		}
		function finish()
		{
	
		}
		function ask_butt(){
			$ask_uri=@$this->content['navigation']['main']['ask'];
			$this->output('<DIV class="'.(qa_opt('tovolt_plugin_e_rtl') ? 'right' : 'left').'"><A href="'.$ask_uri['url'].'" class="ask-button" title="Ask Question">Ask</a></DIV>');
		}

		
		function head_title()
		{
		//$current == 1
			$content=$this->content;
			$menu = @$this->content['navigation']['main']['$']['selected'];
			
			if ( $menu == 1 ){
				$pagetitle =qa_opt('tovolt_plugin_ht');
				$headtitle=(strlen($pagetitle) ? ($pagetitle.' - ') : '').$this->content['site_title'];			
				$this->output('<TITLE>'.$headtitle.'</TITLE>');
				}else{
				$pagetitle=strlen($this->request) ? strip_tags(@$this->content['title']) : '';
				$headtitle=(strlen($pagetitle) ? ($pagetitle.' - ') : '').$this->content['site_title'];			
				$this->output('<TITLE>'.$headtitle.'</TITLE>');
			}
		}
		
		function body_header() // adds login bar, user navigation and search at top of page in place of custom header content
		{
			$this->output('	<header><DIV class="row">');
				
				if (qa_opt('tovolt_plugin_e_rtl') ){
					
					$this->output('<DIV class="four columns">');
					$this->ask_butt();
					$this->output('<section class="users-block left">');				  
								
					if (!qa_is_logged_in()) {
						$this->user_login();
					}else{
						$this->user_tab();
					}
					$this->output('</section></DIV>');
					
					$this->output('<DIV class="six columns">');
					$this->search();
					$this->output('</DIV>');		
					
					$this->output('	<DIV class="two columns">
						<div class="logo left">
							'.$this->content['logo'].'
						</div>
					</DIV>');
				}else{
				
					$this->output('	<DIV class="two columns">
							<div class="logo left">
								'.$this->content['logo'].'
							</div>
						</DIV>');
					$this->output('<DIV class="six columns">');
					$this->search();
					$this->output('</DIV>');
					$this->output('<DIV class="four columns">');
					$this->ask_butt();
					$this->output('<section class="users-block right">');				  
								
					if (!qa_is_logged_in()) {
						$this->user_login();
					}else{
						$this->user_tab();
					}
					$this->output('</section></DIV>');
				}
			$this->output('	</DIV>
			  </header>
			');
        }
		function only_avatar($userid)
		{ 			
			$user=qa_db_select_with_pending(
                qa_db_user_account_selectspec($userid, false)			
			);
			$this->output(qa_get_user_avatar_html($user['flags'], $user['email'], $user['handle'], $user['avatarblobid'], $user['avatarwidth'], $user['avatarheight'], qa_opt('avatar_users_size'), true));	 
		}
		function useravatar()
        {       
			$handle= qa_get_logged_in_handle();

			$user=qa_db_select_with_pending(
				qa_db_user_account_selectspec($handle, false)
			);

			$this->output('<DIV class="top-avatar right">'.qa_get_user_avatar_html($user['flags'], $user['email'], $user['handle'], $user['avatarblobid'], $user['avatarwidth'], $user['avatarheight'], qa_opt('avatar_users_size'), true).'</DIV>');	
			
        }
		function user_login(){
		
			if (!qa_is_logged_in()) {
			$this->output('<DIV class="user-tab login-user right">');
				$login=@$this->content['navigation']['user']['login'];
				$this->output('<a href="#" class="onclick login-button right button" title="login"><i class="icon-lock "></i> Login</a>');
			
			if (isset($login)) {
				$this->output('<UL class="user-nav"><li class="login-form clearfix">');
				$this->output(
					'<form id="qa-loginform" action="'.$login['url'].'" method="post">',
						'<input type="text" id="qa-userid" name="emailhandle" placeholder="'.trim(qa_lang_html('users/email_handle_label'), ':').'" />',
						'<input type="password" id="qa-password" name="password" placeholder="'.trim(qa_lang_html('users/password_label'), ':').'" />',
						'<DIV id="qa-rememberbox"><input type="checkbox" name="remember" id="qa-rememberme" value="1"/>',
						'<label for="qa-rememberme" id="qa-remember">'.qa_lang_html('users/remember').'</label></DIV>',
						'<input type="hidden" name="code" value="'.qa_html(qa_get_form_security_code('login')).'"/>',
						'<input type="submit" value="'.$login['label'].'" id="qa-login" name="dologin" />',
					'</form>',				
					'<!--[End: login form]-->'
				);
				$this->output('</li>',
					'<li class="register"><a class="register-button" href="'.@$this->content['navigation']['user']['register']['url'].'" title="Register with us">Create an account</a></li></ul>');
				$this->output('</DIV>');
				unset($this->content['navigation']['user']['login']); // removes regular navigation link to log in page
				
			}
		}
		
		}
		function short_num($num, $precision = 2) {
		   if ($num >= 1000 && $num < 1000000) {
			$n_format = number_format($num/1000,$precision).'K';
			} else if ($num >= 1000000 && $num < 1000000000) {
			$n_format = number_format($num/1000000,$precision).'M';
		   } else if ($num >= 1000000000) {
		   $n_format=number_format($num/1000000000,$precision).'B';
		   } else {
		   $n_format = $num;
			}
		  return $n_format;
		}

		function user_tab() // adds points count after logged in username
		{			
			$handle= qa_get_logged_in_handle();
			
			$this->output('<DIV class="updates right">');
			$this->notification();
			$this->output('</DIV>');
			
			$this->output('<DIV class="user-tab right"><DIV class="onclick clearfix">');
			$this->useravatar();
			$this->output('<DIV class="right">');
			$this->output('<span class="name">'.qa_get_logged_in_handle().'</span>');
 			if (qa_is_logged_in()) {
				$userpoints=qa_get_logged_in_points();
				
/* 				$pointshtml=($userpoints==1)
					? qa_lang_html_sub('main/1_point', '1', '1')
					: qa_lang_html_sub('main/x_points'); */
						
				$this->output(
					'<SPAN CLASS="points">Points',
					$this->short_num(qa_html($userpoints))  ,
					'</SPAN>'
				);
			} 
			$ac=@$this->content['navigation']['user']['account'];
			$logout=@$this->content['navigation']['user']['logout'];
			$this->output('</DIV></DIV>');
			
			$this->output('<UL class="user-nav">');
			$this->output('<LI class="user-nav-points">');
			 	if (qa_is_logged_in()) {
				$userpoints=qa_get_logged_in_points();
				
 				$pointshtml=($userpoints==1)
					? qa_lang_html_sub('main/1_point', '1', '1')
					: qa_lang_html_sub('main/x_points',qa_html($userpoints)); 
						
				$this->output(
					'<SPAN CLASS="nav-points">',
						$pointshtml  ,
					'</SPAN>'
				);
			} 
			$this->output('</LI>');
			$this->output('<li><a class="nav-user-link" href="'.qa_path_html('user/'.$handle).'" title="My Account"><i class="icon-user-2"></i> My Account</a></li>');
			$this->output('<li><a class="nav-user-link" href="'.$ac['url'].'" title="Edit Profile"><i class="icon-wrench "></i> Edit Account</a></li>');
			$this->output('<li class="separator"></li>');
			$this->output('<li><a class="nav-user-link " href="'.$logout['url'].'" title="Logout"><i class="icon-unlocked"></i> Logout</a></li>');				
			$this->output('</ul></DIV>');
		}
		function header_custom() // allows modification of custom element shown inside header after logo
		{
			if (isset($this->content['body_header'])) {
				$this->output('<DIV CLASS="header-banner">');
				$this->output_raw($this->content['body_header']);
				$this->output('</DIV>');
			}
		}
		
		function header() // removes user navigation and search from header and replaces with custom header content. Also opens new <DIV>s
		{	
			$this->header_custom();			
			//$this->output('<DIV CLASS="row right-content">', '');
		}
		
		
		function title() // add RSS feed icon after the page title
		{
			if (isset($this->content['title']))
				$this->output($this->content['title']);
			
			$feed=@$this->content['feed'];
			
			if (!empty($feed))
				$this->output('<a href="'.$feed['url'].'" title="'.@$feed['label'].'"><img src="'.$this->rooturl.'images/rss.jpg" alt="" /></a>');
		}

		function user_on_hover($userid, $handle)
		{
			$user=qa_db_select_with_pending(
                qa_db_user_account_selectspec($userid, true),
                qa_db_user_profile_selectspec($handle, false),
				qa_db_user_rank_selectspec($handle)
				
			);
			$badge = qa_badge_plugin_user_widget($handle);
			
			//print_r($user);
			$this->output('<DIV class="user-data"><ul class="user-hov-profile">');
				//$this->output('<li class="online">',$is_online,'</li>');
				//$this->output('<li class="avatar">',$avatar,'</li>');
							
				if(isset($user['1']['name'] ) && ($user['1']['name']  != '')) { $this->output('<li class="name">',$user['1']['name'],'</li>'); }else{ $this->output('<li class="name">',$handle,'</li>'); }				
				if(isset($user['0']['points']) && ($user['0']['points'])!= ''){ $this->output('<li class="points icon-trophy ">Points :<span>',$user['0']['points'],'</span></li>');}
				if(isset($user['2']) && ($user['2'])!= ''){
					$this->output('<li class="ranked icon-users-2 ">Ranked : <span>',$user['2'],'</span></li>');
				}
				if(!empty($badge)){	$this->output('<li class="badges icon-shield ">Badages :',$badge,'</li>'); }
					
				if(isset($user['1']['website']) && ($user['1']['website'])!= ''){
				$this->output('<li class="separator"></li>');
				$this->output('<li class="website icon-earth "><a href="http://'.$user['1']['website'].'" title="My Website">',$user['1']['website'],'</a></li>');}
					
				if(isset($user['1']['location']) && ($user['1']['location'])!= ''){	$this->output('<li class="location icon-pushpin ">Location :',$user['1']['location'],'</li>');}
					
				if(isset($user['1']['about']) && ($user['1']['about'])!= ''){
				$this->output('<li class="separator"></li>');
				$this->output('<li class="about icon-happy ">',$user['1']['about'],'</li>');}
			$this->output('</ul></DIV>');
			
		}
		function q_item_stats($q_item) // add view count to question list
		{
			$this->output('<DIV CLASS="qa-q-item-stats"><div class="q-item-avatar">');
			//print_r($q_item);
			$this->output(qa_get_user_avatar_html($q_item['raw']['flags'], $q_item['raw']['email'], $q_item['raw']['handle'], $q_item['raw']['avatarblobid'], $q_item['raw']['avatarwidth'], $q_item['raw']['avatarheight'], qa_opt('avatar_q_page_q_size'), true));
			$this->user_on_hover($q_item['raw']['userid'],$q_item['raw']['handle']);
			$this->output('<div id="facebookG">
				<div id="blockG_1" class="facebook_blockG">
				</div>
				<div id="blockG_2" class="facebook_blockG">
				</div>
				<div id="blockG_3" class="facebook_blockG">
				</div>
			</div>');
			$this->output(
				'</div><SPAN CLASS="q-list-points">',
				$this->short_num($q_item['raw']['points']),
				'</SPAN>'
			);
			if (qa_opt('tovolt_plugin_e_voting')){
				$this->voting($q_item);
			}
			$this->a_count($q_item);			
			$this->view_count($q_item);

			$this->output('</DIV>');
		}		
		
		function body_suffix() // to replace standard Q2A footer
        {
			$this->output('<DIV class="qa-footer-bottom-group">');
			$this->footer();
			$this->output('</DIV>', '');
			$this->output('<div class="addthis-float"><!-- AddThis Button BEGIN -->
<div class="addthis_toolbox addthis_default_style ">
<a class="addthis_button_google_plusone" g:plusone:size="medium"></a> 
<a class="addthis_button_facebook_like" fb:like:layout="button_count"></a>
<a class="addthis_button_tweet" tw:via="ToVolt"></a> 
<a class="addthis_button_linkedin_counter"></a> 

</div>
<script type="text/javascript" src="//s7.addthis.com/js/300/addthis_widget.js#pubid=xa-5131a32061747975"></script>
<!-- AddThis Button END --></div>');
        }
		
		function footer()
		{
			$this->output('<DIV CLASS="qa-footer row">');
			
			$this->nav('footer');
			$this->attribution();
			$this->footer_clear();
			
			$this->output('</DIV> ', '');
		}
		

		function attribution()
		{
			$this->output(
				'<DIV CLASS="qa-attribution">',
				qa_opt('tovolt_plugin_cp'),
				'</div>',
				'</DIV>'
			);

			
		}
		function body_content()
		{	
			$content = $this->content;
			$this->body_prefix();
			$this->notices();
			
			$this->output('<DIV CLASS="row main-c">', '');
			$this->output('<a href="javascript:void(0)" title="Show Menu" class="menu-showhide"><i class="icon-menu"></i></a>');
			if (!qa_opt('tovolt_plugin_e_rtl')) {
				$this->output('<DIV class="left-content">');
				
				$this->output('<NAV>');
				$this->nav('main');	
				
				$this->widgets('side', 'top');					
				$this->output('</NAV>');
				
				$this->output('</DIV>');
			}
			$this->output('<DIV class="'. (qa_opt('tovolt_plugin_e_rtl') ? 'rtl' : '') .' right-content"><DIV class="row">');
			$this->nav('sub');
			
			
			$this->widgets('full', 'top');
			$this->header();
			$this->widgets('full', 'high');	
			$this->main();			
			if (!isset($content['widgets']['main']['high']) && isset($content['widgets']['side'])){
				$this->sidepanel();					
			}
			
			$this->widgets('full', 'low');
			//$this->footer();
			$this->widgets('full', 'bottom');
			
			$this->output('</DIV></DIV>');
			
			if (qa_opt('tovolt_plugin_e_rtl')) {
				$this->output('<DIV class="left-content">');
				
				$this->output('<NAV>');
				$this->nav('main');	
				
				$this->widgets('side', 'top');					
				$this->output('</NAV>');
				
				$this->output('</DIV>');
			}
			
			$this->output('</DIV>');
			
			$this->body_suffix();
		}

		function page_title_error()
		{
			$favorite=@$this->content['favorite'];
			
			
				
			$this->output('<div class="title-c"><H1 class="title">');
			
			$this->title();
			$this->output('</H1>');
			if (isset($favorite))
				$this->output('<FORM '.$favorite['form_tags'].'>');
				$this->favorite();
			if (isset($this->content['error']))
				$this->error(@$this->content['error']);

			if (isset($favorite)) {
				$this->form_hidden_elements(@$favorite['form_hidden']);
				$this->output('</FORM>');
			}
			$this->output('</div>');
		}
		function favorite_button($tags, $class)
		{
			if (isset($tags))
				$this->output('<BUTTON '.$tags.' TYPE="submit" VALUE="" CLASS="'.$class.
					'-button" onmouseover="this.className=\''.$class.'-hover\';" onmouseout="this.className=\''.$class.'-button\';"><i class="icon-star"></i> </BUTTON>');
		}
		function sidepanel()
		{
			$this->output('<DIV CLASS="three columns sidepanel  '. (qa_opt('tovolt_plugin_e_rtl') ? 'pull-nine' : '').'">');			
			$this->sidebar();
			$this->widgets('side', 'high');
			$this->nav('cat', 1);
			$this->widgets('side', 'low');
			$this->output_raw(@$this->content['sidepanel']);
			$this->feed();
			$this->widgets('side', 'bottom');
			$this->output('</DIV>', '');
		}
		function main()
		{		
			$content=$this->content;
			if(!isset($content['widgets']['side']) && !isset ($content['widgets']['main']['high'])){
				$main_class = 'twelve';
				$border_style = '';
			}else{
				$main_class = 'nine '. (qa_opt('tovolt_plugin_e_rtl') ? 'push-three' : '');
				$border_style = 'style="border-right: 1px solid #EEEEEE"';
			}
			if (isset ($content['widgets']['main']['high']))
				$this->page_title_error();
				
			$this->output('<DIV CLASS="'.$main_class.' columns main '.(@$this->content['hidden'] ? ' qa-main-hidden' : '').'" '.$border_style.'>');
			
			if (!isset ($content['widgets']['main']['high']))
				$this->page_title_error();
				
			$this->widgets('main', 'top');					
				
			$this->main_parts($content);
			//print_r($content['q_view']['when']['data']);	
				
			$this->widgets('main', 'low');

			$this->page_links();
			$this->suggest_next();
			
			$this->widgets('main', 'bottom');
			
			$this->output('</DIV>');
			$this->main_sidebar();
		}
		function main_sidebar()
		{
			$content=$this->content;
			if (!empty ($content['widgets']['main']['high'])){								
				$this->output('<DIV class="main-sidebar three columns '. (qa_opt('tovolt_plugin_e_rtl') ? 'pull-nine' : '').'">');

				$this->output('<div class="question-more-data"><ul>');
				$this->output('<li class="icon-bubble"><span class="question-asked-time">Asked ',@$content['q_view']['when']['data'].' '.@$content['q_view']['when']['suffix'],'</span></li>');
				$this->output('<li class="icon-eye-2"><span class="question-views">Viewed ',@$content['q_view']['views_raw'],' times</span></li>');
				$this->output('</ul><h4 class="view-sidebar-title">Tagged</h4>');
				$this->post_tags(@$content['q_view'], 'view-sidebar');
				$this->output('</DIV>');
				if(qa_opt('tovolt_plugin_e_ad2')==1){
					$this->output('<div class="adsence clearfix">');
						$this->output(qa_opt('tovolt_plugin_ad2'));
					$this->output('</div>');
				}	
				$this->widgets('main', 'high');
				
				$this->output('</DIV>');
			}
		}
		function search_button($search)
		{
			$this->output('<BUTTON TYPE="submit" CLASS="qa-search-button"><i class="icon-search "></i></button>');
		}
		

		function q_item_main($q_item)
		{			
			$this->output('<DIV CLASS="qa-q-item-main">');		
			
			$this->q_item_title($q_item);
				
			$this->q_item_content($q_item);	
			$this->post_meta($q_item, 'qa-q-item');			
			$this->post_tags($q_item, 'qa-q-item');
			$this->q_item_buttons($q_item);

			$this->output('</DIV>');
		}
		
		function post_avatar($post, $class, $prefix=null)
		{
			if (isset($post['avatar'])) {
				if (isset($prefix))
					$this->output($prefix);

				$this->output('<DIV CLASS="'.$class.'-avatar avatar-with-data">');
				$this->output($post['avatar']);
				$this->user_on_hover($post['raw']['userid'],$post['raw']['handle']);
				$this->output('<div id="facebookG">
						<div id="blockG_1" class="facebook_blockG">
						</div>
						<div id="blockG_2" class="facebook_blockG">
						</div>
						<div id="blockG_3" class="facebook_blockG">
						</div>
					</div>');
				$this->output('</DIV>');
			}
		}
		function q_view_stats($q_view)
		{
			$this->output('<DIV class="q-view-main-stats">');
				$this->post_avatar($q_view,'main-stats');
				if (isset($q_view['avatar'])) {
					$this->output(
						'<SPAN CLASS="q-list-points">',
						$this->short_num($q_view['raw']['points']),
						'</SPAN>'
					);
				
				}
				
			$this->output('</DIV>');
			
		}
		
		function q_view_main($q_view)
		{
		
			$this->output('<DIV CLASS="qa-q-view-main">');

			if (isset($q_view['main_form_tags']))
				$this->output('<FORM '.$q_view['main_form_tags'].'>'); // form for buttons on question
			
			$this->output('<DIV class="view-main-left">');
			$this->q_view_stats($q_view);
			$this->output('</DIV><DIV class="view-main-right">');
			$this->post_meta_author($q_view, 'qa-q-view');
			$this->q_view_content($q_view);
			$this->q_view_extra($q_view);
			$this->q_view_follows($q_view);
			$this->q_view_closed($q_view);
			
			
			//$this->post_tags($q_view, 'qa-q-view');			
			$this->post_meta_other($q_view, 'qa-q-view');
			$this->q_view_buttons($q_view);

			$this->c_list(@$q_view['c_list'], 'qa-q-view');
			$this->output('</DIV>');
			if(qa_opt('tovolt_plugin_e_ad1')==1){
				$this->output('<div class="adsence">');
					$this->output(qa_opt('tovolt_plugin_ad1'));
				$this->output('</div>');
			}
			if (isset($q_view['main_form_tags'])) {
				$this->form_hidden_elements(@$q_view['buttons_form_hidden']);
				$this->output('</FORM>');
			}
			
			$this->c_form(@$q_view['c_form']);

			$this->output('</DIV> <!-- END qa-q-view-main -->');
		}
		function q_view($q_view)
		{

			if (!empty($q_view)) {
				$this->output('<DIV CLASS="qa-q-view'.(@$q_view['hidden'] ? ' qa-q-view-hidden' : '').rtrim(' '.@$q_view['classes']).'"'.rtrim(' '.@$q_view['tags']).'>');
				
				if (isset($q_view['main_form_tags']))
					$this->output('<FORM '.$q_view['main_form_tags'].'>'); // form for voting buttons
				
				$this->voting($q_view);				
				if (isset($q_view['main_form_tags'])) {
					$this->form_hidden_elements(@$q_view['voting_form_hidden']);
					$this->output('</FORM>');
				}
				$this->a_count($q_view);
				$this->q_view_main($q_view);
				
				$this->output('</DIV> <!-- END qa-q-view -->', '');

			}
		}
		function voting($post)
		{
			if (isset($post['vote_view'])) {
				$this->output('<DIV CLASS="qa-voting '.(($post['vote_view']=='updown') ? 'qa-voting-updown' : 'qa-voting-net').'" '.@$post['vote_tags'].'>');
				$this->voting_inner_html($post);
				$this->output('</DIV>');
			}
		}
		
		function vote_buttons($post)
		{
			$this->output('<DIV CLASS="qa-vote-buttons '.(($post['vote_view']=='updown') ? 'qa-vote-buttons-updown' : 'qa-vote-buttons-net').'">');

			switch (@$post['vote_state'])
			{
				case 'voted_up':
					$this->new_post_hover_button($post, 'vote_up_tags', '+', 'qa-vote-first-button qa-vote-one-button qa-voted-up', 'icon-playUp');
					$this->output('<button class="qa-vote-second-button qa-vote-up-button vote-disabled" disabled="disabled" title="Disabled"><i class="icon-playDown"></i></button>');
					break;
					
				case 'voted_up_disabled':
					$this->new_post_disabled_button($post, 'vote_up_tags', '+', 'qa-vote-one-button qa-vote-up', 'icon-playUp ');
					break;
					
				case 'voted_down':
					$this->output('<button class="qa-vote-first-button qa-vote-up-button vote-disabled" disabled="disabled" title="Disabled"><i class="icon-playDown "></i></button>');
					$this->new_post_hover_button($post, 'vote_down_tags', '&ndash;', 'qa-vote-second-button qa-voted-down', 'icon-playDown ');
					break;
					
				case 'voted_down_disabled':
					$this->new_post_disabled_button($post, 'vote_down_tags', '&ndash;', 'qa-vote-one-button qa-vote-down', 'icon-playDown ');
					break;
					
				case 'up_only':
					$this->new_post_hover_button($post, 'vote_up_tags', '+', 'qa-vote-first-button qa-vote-up', 'icon-playUp');
					$this->new_post_disabled_button($post, 'vote_down_tags', '', 'qa-vote-second-button qa-vote-down', 'icon-playDown');
					break;
				
				case 'enabled':
					$this->new_post_hover_button($post, 'vote_up_tags', '+', 'qa-vote-first-button qa-vote-up', 'icon-playUp');
					$this->new_post_hover_button($post, 'vote_down_tags', '&ndash;', 'qa-vote-second-button qa-vote-down', 'icon-playDown');
					break;

				default:
					$this->new_post_disabled_button($post, 'vote_up_tags', '', 'qa-vote-first-button qa-vote-up', 'icon-playUp');
					$this->new_post_disabled_button($post, 'vote_down_tags', '', 'qa-vote-second-button qa-vote-down', 'icon-playDown');
					break;
			}

			$this->output('</DIV>');
		}
		
 		function new_post_hover_button($post, $element, $value, $class, $icon)
		{
			if (isset($post[$element]))
				$this->output('<BUTTON '.$post[$element].' TYPE="submit" VALUE="'.$value.'" CLASS="'.$class.
					'-button" onmouseover="this.className=\''.$class.'-hover\';" onmouseout="this.className=\''.$class.'-button\';"><i class="'.$icon.'"></i></BUTTON>');
		}
		function new_post_disabled_button($post, $element, $value, $class, $icon)
		{
			if (isset($post[$element]))
				$this->output('<BUTTON '.$post[$element].' TYPE="submit" VALUE="'.$value.'" CLASS="'.$class.'-disabled" DISABLED="disabled"><i class="'.$icon.'"></i></BUTTON>');
		} 
		
		function voting_inner_html($post)
		{			
			$this->vote_count($post);
			$this->vote_buttons($post);
			$this->vote_clear();
		}
		
		function a_selection($post)
		{
			$this->output('<DIV CLASS="qa-a-selection">');
			
			if (isset($post['select_tags']))
				$this->new_post_hover_button($post, 'select_tags', '', 'qa-a-select', 'icon-checkmark');
			elseif (isset($post['unselect_tags']))
				$this->new_post_hover_button($post, 'unselect_tags', '', 'qa-a-unselect', 'icon-checkmark');
			elseif ($post['selected'])
				$this->output('<DIV CLASS="qa-a-selected">&nbsp;</DIV>');
			
			if (isset($post['select_text']))
				$this->output('<DIV CLASS="qa-a-selected-text">'.@$post['select_text'].'</DIV>');
			
			$this->output('</DIV>');
		}
		
		function post_meta($post, $class, $prefix=null, $separator='')
		{
			$this->output('<DIV CLASS="'.$class.'-meta">');
			
			if (isset($prefix))
				$this->output($prefix);
			$this->output('<DIV CLASS="meta-group">');
			$order=explode('^', @$post['meta_order']);			
			foreach ($order as $element)
				switch ($element) {
					case 'what':
						$this->post_meta_what($post, $class);
						break;
						
					case 'when':
						$this->post_meta_when($post, $class);
						break;
						
					case 'where':
						$this->post_meta_where($post, $class);
						break;
						
				/* 	case 'who':
						$this->post_meta_who($post, $class);
						break; */
				}
			$this->output('</DIV>');	
			//$this->post_meta_flags($post, $class);
			
/* 			if (!empty($post['what_2'])) {
				$this->output('<DIV CLASS="meta-group">');
				//$this->output($separator);
				
				foreach ($order as $element)
					switch ($element) {
						case 'what':
							$this->output('<SPAN CLASS="'.$class.'-what">'.$post['what_2'].'</SPAN>');
							break;
						
						case 'when':
							$this->output_split(@$post['when_2'], $class.'-when');
							break;
						
						case 'who':
							$this->output_split(@$post['who_2'], $class.'-who');
							break;
					}
				$this->output('</DIV>');
			} */
			
			$this->output('</DIV>');
		}
	
		function a_item_main($a_item)
		{
			$this->output('<DIV CLASS="qa-a-item-main">');
			
			if (isset($a_item['main_form_tags']))
				$this->output('<FORM '.$a_item['main_form_tags'].'>'); // form for buttons on answer
			
			$this->output('<DIV CLASS="a-main-left">');
				$this->post_avatar($a_item,'ans-stats');
				if (isset($a_item['avatar'])) {
					$this->output(
						'<SPAN CLASS="q-list-points">',
						$this->short_num($a_item['raw']['points']),
						'</SPAN>'
					);
				}
				$this->a_selection($a_item);
			$this->output('</DIV><DIV CLASS="a-main-right">');
			
			if ($a_item['hidden'])
				$this->output('<DIV CLASS="qa-a-item-hidden">');
			elseif ($a_item['selected'])
				$this->output('<DIV CLASS="qa-a-item-selected">');
			$this->post_meta_author($a_item, 'qa-q-view');
			$this->error(@$a_item['error']);
			$this->a_item_content($a_item);
			$this->post_meta_other($a_item, 'qa-q-view');
			
			if ($a_item['hidden'] || $a_item['selected'])
				$this->output('</DIV>');
			
			$this->a_item_buttons($a_item);
			
			$this->c_list(@$a_item['c_list'], 'qa-a-item');
			$this->output('</DIV>');
			if (isset($a_item['main_form_tags'])) {
				$this->form_hidden_elements(@$a_item['buttons_form_hidden']);
				$this->output('</FORM>');
			}

			$this->c_form(@$a_item['c_form']);

			$this->output('</DIV> <!-- END qa-a-item-main -->');
		}
	
		function post_meta_author($post, $class, $prefix=null)
		{
			$this->output('<DIV CLASS="'.$class.'-meta">');
			
			if (isset($prefix))
				$this->output($prefix);
			
			$order=explode('^', @$post['meta_order']);
			$this->output('<DIV CLASS="meta-group-author">');
			foreach ($order as $element)
				switch ($element) {
					case 'what':
						$this->post_meta_what($post, $class);
						break;
						
					case 'when':
						$this->post_meta_when($post, $class);
						break;
						
					case 'where':
						$this->post_meta_where($post, $class);
						break;
						
					case 'who':
						$this->post_meta_who($post, $class);
						break;
				}
			$this->output('</DIV>');	
			$this->post_meta_flags($post, $class);
			
			$this->output('</DIV>');
		}
		function post_meta_other($post, $class, $prefix=null)
		{
			
			if (isset($prefix))
				$this->output($prefix);
			$order=explode('^', @$post['meta_order']);				
			$this->post_meta_flags($post, $class);
			
			if (!empty($post['what_2']) ) {
			$this->output('<DIV CLASS="'.$class.'-meta clearfix"><DIV class="other-meta right">');		
			
				$this->output('<DIV class="meta-other-avatar">');
				
				$dom = new DOMDocument;
				$dom->loadHTML($post['who_2']['data']);
				foreach ($dom->getElementsByTagName('a') as $node) {
					$url = $node->getAttribute( 'href' );
				}
				$handle = strrpos( $url, '/' )+1;
				
				$this->only_avatar($handle);
				$this->output('</DIV>');			
				$this->output('<DIV CLASS="meta-group-other">');				
				foreach ($order as $element)
					switch ($element) {
						case 'what':
							$this->output('<SPAN CLASS="'.$class.'-what">'.$post['what_2'].'</SPAN>');
							break;
						
						case 'when':
							$this->output_split(@$post['when_2'], $class.'-when');
							break;
						
						case 'who':
							$this->output_split(@$post['who_2'], $class.'-who');
							break;
					}
				$this->output('</DIV>');
				$this->output('</DIV></DIV>');
			}
			
			
		}
		
		function form_button_data($button, $key, $style)
		{
			$baseclass='qa-form-'.$style.'-button qa-form-'.$style.'-button-'.$key;
			$hoverclass='qa-form-'.$style.'-hover qa-form-'.$style.'-hover-'.$key;
			
			$this->output('<BUTTON'.rtrim(' '.@$button['tags']).' TITLE="'.@$button['popup'].'" TYPE="submit"'.
				(isset($style) ? (' CLASS="'.$baseclass.'" onmouseover="this.className=\''.$hoverclass.'\';" onmouseout="this.className=\''.$baseclass.'\';"') : '').'>'.@$button['label'].'</BUTTON>');
		}
		
		function related_qs($q_list)
		{
			if (!empty($q_list)) {				
				$this->related_list($q_list);
			}
		}
		
		function related_list($q_list)
		{
			if (isset($q_list['qs'])) {
				$this->output('<ul CLASS="related-q-list'.($this->list_vote_disabled($q_list['qs']) ? ' qa-q-list-vote-disabled' : '').'">', '');
				
				foreach ($q_list['qs'] as $q_item)
					$this->output('<li><A HREF="'.$q_item['url'].'">'.$q_item['title'].'</A></li>');
	
				$this->output('</ul>', '');
			}
		}		

		function a_list($a_list)
		{
		
			if (!empty($a_list)) {
				$this->output('<DIV class="answer-list">');

				if (!empty($a_list['title']) ){
					$this->output('<H2 class="answer-title">'.@$a_list['title'].'</H2>');
				}
				
				$this->output('<DIV CLASS="qa-a-list'.($this->list_vote_disabled($a_list['as']) ? ' qa-a-list-vote-disabled' : '').'" '.@$a_list['tags'].'>', '');
				
				foreach ($a_list['as'] as $a_item)
					$this->a_list_item($a_item);
				
				$this->output('</DIV></DIV> <!-- END qa-a-list -->', '');
								
			}
		}
		
		function c_item_main($c_item)
		{
			$this->error(@$c_item['error']);

			if (isset($c_item['expand_tags']))
				$this->c_item_expand($c_item);
			elseif (isset($c_item['url']))
				$this->c_item_link($c_item);
			else
				$this->c_item_content($c_item);
			
			$this->output('<DIV CLASS="qa-c-item-footer">');
			$this->post_avatar_meta_c($c_item, 'qa-c-item');
			$this->c_item_buttons($c_item);
			$this->output('</DIV>');
		}
		function post_avatar_meta_c($post, $class, $avatarprefix=null, $metaprefix=null, $metaseparator='<BR/>')
		{
			$this->output('<SPAN CLASS="'.$class.'-avatar-meta">');
			$this->post_avatar_c($post, $class, $avatarprefix);
			$this->post_meta_c($post, $class, $metaprefix, $metaseparator);
			$this->output('</SPAN>');
		}
		function post_avatar_c($post, $class, $prefix=null)
		{
			if (isset($post['avatar'])) {
				if (isset($prefix))
					$this->output($prefix);

				$this->output(
					'<SPAN CLASS="'.$class.'-avatar">',
					$post['avatar'],
					'</SPAN>'
				);
			}
		}
		
		function post_meta_c($post, $class, $prefix=null, $separator='<BR/>')
		{
			$this->output('<SPAN CLASS="'.$class.'-meta">');
			
			if (isset($prefix))
				$this->output($prefix);
			
			$order=explode('^', @$post['meta_order']);
			
			foreach ($order as $element)
				switch ($element) {
					case 'what':
						$this->post_meta_what($post, $class);
						break;
						
					case 'when':
						$this->post_meta_when($post, $class);
						break;
						
					case 'where':
						$this->post_meta_where($post, $class);
						break;
						
					case 'who':
						$this->post_meta_who($post, $class);
						break;
				}
				
			$this->post_meta_flags($post, $class);
			
			if (!empty($post['what_2'])) {
				$this->output($separator);
				
				foreach ($order as $element)
					switch ($element) {
						case 'what':
							$this->output('<SPAN CLASS="'.$class.'-what">'.$post['what_2'].'</SPAN>');
							break;
						
						case 'when':
							$this->output_split(@$post['when_2'], $class.'-when');
							break;
						
						case 'who':
							$this->output_split(@$post['who_2'], $class.'-who');
							break;
					}
			}
			
			$this->output('</SPAN>');
		}
		
		function feed()
		{
			$feed=@$this->content['feed'];
			
			if (!empty($feed)) {
				$this->output('<DIV CLASS="qa-feed">');
				$this->output('<A HREF="'.$feed['url'].'" CLASS="qa-feed-link icon-feed">'.@$feed['label'].'</A>');
				$this->output('</DIV>');
			}
		}
		
		function ranking($ranking)
		{
			$this->section(@$ranking['title']);
			
			$class=(@$ranking['type']=='users') ? 'qa-top-users' : 'qa-top-tags';
			
			$rows=min($ranking['rows'], count($ranking['items']));
			
			if ($rows>0) {
				$this->output('<DIV CLASS="'.$class.'-div">');
			
				$columns=ceil(count($ranking['items'])/$rows);
				
				for ($row=0; $row<$rows; $row++) {
					$this->set_context('ranking_row', $row);
					
		
					for ($column=0; $column<$columns; $column++) {
						$this->set_context('ranking_column', $column);
						$this->ranking_item(@$ranking['items'][$column*$rows+$row], $class, $column>0);
					}

					$this->clear_context('ranking_column');
		
					
				}
			
				$this->clear_context('ranking_row');

				$this->output('</DIV>');
			}
		}
		function ranking_item($item, $class, $spacer)
		{
			$this->output('<DIV class="list-box user-box-'.$class.' clearfix">');
			if ($spacer)
				$this->ranking_spacer($class);
			
			if (empty($item)) {
				$this->ranking_spacer($class);
				$this->ranking_spacer($class);
			
			} else {
				if (isset($item['count']))
					$this->ranking_count($item, $class);
					
				$this->ranking_label($item, $class);
					
				if (isset($item['score']))
					$this->ranking_score($item, $class);
			}
			$this->output('</DIV>');
		}
		function ranking_spacer($class)
		{
			$this->output('<DIV CLASS="'.$class.'-spacer">&nbsp;</DIV>');
		}
		
		function ranking_count($item, $class)
		{
			$this->output('<DIV CLASS="'.$class.'-count">'.$item['count'].' &#215;'.'</DIV>');
		}
		
		function ranking_label($item, $class)
		{
			$this->output('<div CLASS="'.$class.'-label">'.$item['label'].'</div>');
		}
		
		function ranking_score($item, $class)
		{
			$this->output('<div CLASS="'.$class.'-score">'.$item['score'].'</div>');
		}
		
		
		function search_field($search)
		{
			$this->output('<INPUT TYPE="text" '.$search['field_tags'].' placeholder="'.@qa_lang('Search for question and answer').'" VALUE="'.@$search['value'].'" CLASS="qa-search-field"/>');
		}
	
	}
	 

/*
	Omit PHP closing tag to help avoid accidental output
*/